VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CToolTips32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public gHWndToolTip As Long
Private Type RECT
Left As Long
Top As Long
Right As Long
Bottom As Long
End Type

Private Type TOOLINFO
cbSize As Long
uFlags As Long
hWnd As Long
uId As Long
rct As RECT
hInst As Long
lpszText As String 'Long
End Type

Private Type POINTAPI
x As Long
y As Long
End Type

Private Type msg
hWnd As Long
message As Long
wParam As Long
lParam As Long
Time As Long
pt As POINTAPI
End Type

Private Type NMHDR
hwndFrom As Long
idfrom As Long
code As Long
End Type

Private Type ToolTipText
hdr As NMHDR
lpszText As Long
szText As String * 80
hInst As Long
uFlags As Long
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControls Lib "Comctl32.dll" ()
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
#If UNICODE Then
Private Declare Function SendMessage Lib "user32" Alias "SendMessageW" (ByVal hWnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowEX Lib "user32" Alias "CreateWindowExW" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcW" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongW" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongW" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
#Else
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowEX Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
#End If
'Misc Constants
Private Const H_MAX As Long = &HFFFF + 1
Private Const TOOLTIPS_CLASS = "tooltips_class32"
Private Const WS_EX_TOPMOST = &H8&
Private Const CW_USEDEFAULT  As Long = &H80000000
Private Const GDI_ERROR = &HFFFF

'Windows Messages
Private Const WM_CANCELMODE = &H1F

'Resource String Indexes
Private Const giINVALID_PIC_TYPE As Integer = 10

'Get Windows Long Constants
Private Const GWL_USERDATA = (-21)
Private Const GWL_WNDPROC = (-4)

 

'Messages to relay to ToolTip
Private Const WM_USER = &H400
Private Const WM_NOTIFY = &H4E
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208

'ToolTip style
Private Const TTF_IDISHWND = &H1

'Tool Tip messages
Private Const TTM_ACTIVATE = (WM_USER + 1)
#If UNICODE Then
    Private Const TTM_ADDTOOLW = (WM_USER + 50)
    Private Const TTM_ADDTOOL = TTM_ADDTOOLW
#Else
    Private Const TTM_ADDTOOLA = (WM_USER + 4)
    Private Const TTM_ADDTOOL = TTM_ADDTOOLA
#End If
Private Const TTM_RELAYEVENT = (WM_USER + 7)

'ToolTip Notification
Private Const TTN_FIRST = (H_MAX - 520&)
#If UNICODE Then
    Private Const TTN_NEEDTEXTW = (TTN_FIRST - 10&)
    Private Const TTN_NEEDTEXT = TTN_NEEDTEXTW
#Else
    Private Const TTN_NEEDTEXTA = (TTN_FIRST - 0&)
    Private Const TTN_NEEDTEXT = TTN_NEEDTEXTA
#End If

'Misc ToolTip
Private Const LPSTR_TEXTCALLBACK As Long = -1

 'VB Errors
Private Const giOBJECT_VARIABLE_NOT_SET As Integer = 91
Private Const giINVALID_PICTURE As Integer = 481
Private Const giDLL_FUNCTION_NOT_FOUND As Integer = 453

'Windows Errors
Private Const ERROR_CALL_NOT_IMPLEMENTED As Long = 120



 
Public Sub AddTool(hWnd As Long)
 'Add the hWnd of the Control being subclassed
   
Dim ti As TOOLINFO

With ti
.cbSize = Len(ti)
.uId = hWnd
.hWnd = hWnd
.hInst = App.hInstance
.uFlags = TTF_IDISHWND
.lpszText = LPSTR_TEXTCALLBACK
End With

SendMessage gHWndToolTip, TTM_ADDTOOL, 0, ti
SendMessage gHWndToolTip, TTM_ACTIVATE, 1, ByVal hWnd

    Exit Sub
End Sub
 
Private Sub Class_Initialize()
   InitCommonControls
            gHWndToolTip = CreateWindowEX(WS_EX_TOPMOST, TOOLTIPS_CLASS, vbNullString, 0, _
                      CW_USEDEFAULT, CW_USEDEFAULT, _
                      CW_USEDEFAULT, CW_USEDEFAULT, _
                      0, 0, _
                      App.hInstance, _
                      ByVal 0)
            SendMessage gHWndToolTip, TTM_ACTIVATE, 1, ByVal 0
            
  
End Sub
Public Property Get ToolTipText() As String
    ToolTipText = ToolTipText
End Property
Public Property Let ToolTipText(ByVal sToolTip As String)
    ToolTipText = sToolTip
    
    If Len(sToolTip) <> 0 Then mbToolTipNotInExtender = True
   
End Property
 

 
Public Sub Create()
InitCommonControls
            gHWndToolTip = CreateWindowEX(WS_EX_TOPMOST, TOOLTIPS_CLASS, vbNullString, 0, _
                      CW_USEDEFAULT, CW_USEDEFAULT, _
                      CW_USEDEFAULT, CW_USEDEFAULT, _
                      0, 0, _
                      App.hInstance, _
                      ByVal 0)
            SendMessage gHWndToolTip, TTM_ACTIVATE, 1, ByVal 0
         
End Sub
